% Program

%- PROGRAM START -%
		entry

%- Storing a literal(2) for later use -%
        addi r2,R0,2
        sw lit_2(R0),r2

%- Assigning a variable -%
        lw r2,lit_2(R0)
        sw var_x(R0),r2

%- Storing a literal(4) for later use -%
        addi r2,R0,4
        sw lit_1(R0),r2

%- Arithmetic operation(+) -%
        lw r2,var_x(R0)
        lw r3,lit_1(R0)
        add r2,r2,r3
        sw temp_1(R0),r2

%- Assigning a variable -%
        lw r2,temp_1(R0)
        sw var_x(R0),r2

%- Writing to console -%
        lw R1,var_x(R0)
        jl R15,putint
		
		hlt
%- PROGRAM END -%

% Data
var_x	res	4
temp_1	res 4
lit_1	res	4
lit_2	res 4



% Procedures
%--------------------------------------------------------------%
% putint                                                       %
%--------------------------------------------------------------%
% Write an integer number to stdout. Transform the number into
% ASCII string taking the sign into account.
% Entry : integer number -> r1
% Exit : none.
%
putint	align
	add	r2,r0,r0		% Initialize buffer's index i
	cge	r3,r1,r0		% True if N >= 0
	bnz	r3,putint1		% Branch if True (N >= 0)
	sub	r1,r0,r1		% N = -N
putint1	modi	r4,r1,10		% Rightmost digit
	addi	r4,r4,48		% Convert to ch
	divi	r1,r1,10		% Truncate rightmost digit
	sb	putint9(r2),r4		% Store ch in buffer
	addi	r2,r2,1			% i++
	bnz	r1,putint1		% Loop if not finished
	bnz	r3,putint2		% Branch if True (N >= 0)
	addi	r3,r0,45
	sb	putint9(r2),r3		% Store '-' in buffer
	addi	r2,r2,1			% i++
	add	r1,r0,r0		% Initialize output register (r1 = 0)
putint2	subi	r2,r2,1			% i--
	lb	r1,putint9(r2)		% Load ch from buffer
	putc	r1			% Output ch
	bnz	r2,putint2		% Loop if not finished
	addi r2,R0,10		% Print a newline
	putc r2			% Print a newline
	jr	r15			% return to the caller
putint9	res	12			% loacl buffer (12 bytes)
	align