import static org.junit.Assert.*;
import java.util.List;
import org.junit.jupiter.api.Test;

public class MoonTest {
	
	@Test
	public void executeSimpleMoonProgram_withPutStatements_getPrintedResults() {
		String moonFile = "simple.m";
		CodeGenHelper.MoonResult result = CodeGenHelper.executeMoonProgram(moonFile);

		List<String> output = result.getUsefulOutput();
		System.out.println(result);
		assertEquals(4, output.size());
		assertEquals("Z", output.get(0));
		assertEquals("a", output.get(1));
		assertEquals("c", output.get(2));
		assertEquals("h", output.get(3));
	}
}
